<?php
/*
Template Name: Archives
*/

/* A 'theme plugin' to display all archives in expandable/collapsible nested lists, months under years and days under months. Place this file in your theme folder and create a page using the "Archives" template, just as usual.

By Emily Ravenwood, list function adapted from Jon Ahnold's hack.
License: GPLv3
*/
?>
<?php //Adapted from:
# All Archives Hack for WordPress
# Jon Anhold <jon@imagesafari.com> 9/2003
# Please keep this attribution in place.
//by Emily Ravenwood

function get_nested_allarchives() {

global $wpdb;

$baseurl = get_option('siteurl');

      $query1 = "select distinct date_format(post_date,'%Y') as year from $wpdb->posts where post_status = 'publish' order by year desc";

        $res1 = mysql_query($query1) or print mysql_error();
                
        print "<div id=\"archives-wrapper\"><ul id=\"archives-list\">\n";
        $i = 0;
        while ($row1 = mysql_fetch_assoc($res1)) {
            $i++;    
            $year = $row1['year'];
        
            $query4 = "select distinct date_format(post_date,'%M') as month from $wpdb->posts where date_format(post_date,'%Y') = '$year' and post_status = 'publish' order by post_date
asc";

            $res4 = mysql_query($query4) or error_log(mysql_error());

			$yearlink = $baseurl . '/?m=' . $year;
	
            print "<li id=\"$year-list\" class=\"year-link\"><a href=\"$yearlink\">$year</a> <span class=\"archive-toggle\">(<a href=\"#\" id=\"$year-child-link\" onclick=\"section_toggle('$year-child'); return false\">Expand</a>)</span>\n"; //start year li
    
            $query2 = "select distinct date_format(post_date,'%Y%m') as lmonth,date_format(post_date,'%M') as month,date_format(post_date,'%m') as smonth from $wpdb->posts where date_format(post_date,'%Y') = '$year' and post_status = 'publish' order by post_date  desc";
            $res2 = mysql_query($query2);
            print "<ul id=\"$year-child\" class=\"year-child\" style=\"display:none;\">\n"; //start months ul
			
            while ($row2 = mysql_fetch_assoc($res2)) {
                $i++;
                $month = $row2['month']; //month name
                $lmonth = $row2['lmonth']; // yearmonth numbers
				$smonth = $row2['smonth']; // month numbers ,date_format(post_date,'%m') as smonth?
				
				$monthlink = $baseurl . '/?m=' . $lmonth;
				
                print "<li id=\"$lmonth-list\" class=\"month-link\"><a href=\"$monthlink\">$month</a> <span class=\"archive-toggle\">(<a href=\"#\" id=\"$lmonth-child-link\" onclick=\"section_toggle('$lmonth-child'); return false\">Expand</a>)</span>\n"; //start month li

                $query3 = "select date_format(post_date,'%M %e') as day,date_format(post_date,'%e') as jday,post_title as title,post_date as sort_date,id as post_id from $wpdb->posts where date_format(post_date,'%M') = '$month' and date_format(post_date,'%Y') = '$year' and post_status = 'publish' order by sort_date desc";

                $res3 = mysql_query($query3);

                print "<ul id=\"$lmonth-child\" class=\"month-child\" style=\"display:none;\">\n"; //start days ul

                while ($row3 = mysql_fetch_assoc($res3)) {
                    $i++;
                    $day = $row3['day'];
					$jday = $row3['jday'];
                    $title = stripslashes($row3['title']);
                    $post_id = $row3['post_id'];
					
					$daylink = $baseurl . '/?m=' . $lmonth . $jday;
					
					$postlink = $baseurl . '/?p=' . $post_id;

                    print "<li class=\"day-link\"><a href=\"$daylink\">$day</a> - <a href=\"$postlink\">$title</a></li>\n"; //day li

                }
                print "</ul>\n"; //end days ul
				
				print "</li>\n"; //end month li
            }
			
			print "</ul>\n"; //end months ul

        }
        
        print "</li>\n"; //end year li
		
		print "</ul>\n"; //end whole list ul

        print "</div>\n";
}?>

<script type="text/javascript" language="javascript">
//Ajax fold/unfold function for archives
function section_toggle(sectionid) {
var foldlink = sectionid+'-link';
  if(document.getElementById(sectionid).style.display=='none') {
    document.getElementById(sectionid).style.display='block';
  } 
  else {
   document.getElementById(sectionid).style.display='none';
  }
   if(document.getElementById(foldlink).innerHTML=='Expand') {
    document.getElementById(foldlink).innerHTML='Collapse';
  } 
  else {
   document.getElementById(foldlink).innerHTML='Expand';
  }
}
</script>

<style>
#archives-wrapper {} /* enclosing div*/

#archives-list { list-style: none;} /* ul around whole thing */

	#archives-list li { margin: .5em 0; }

.year-link {} /* li containing year */

.year-child { list-style: none; } /* ul containing months of that year */

.month-link {} /* li containing month */

.month-child { list-style: none; } /* ul containing days of that month */

.day-link {} /* li containing day */

.archive-toggle { font-size: x-small;} /* span around link to open and close sections */
</style>


<?php /* WP Default Compatible; replace with your theme's page.php code, remembering to put the following code after the_content:

				<ul>
					<?php get_nested_allarchives(); ?>
				</ul>
*/
				
get_header(); ?>

	<div id="content" class="narrowcolumn">

		<?php if (have_posts()) : while (have_posts()) : the_post(); ?>
		<div class="post" id="post-<?php the_ID(); ?>">
		<h2><?php the_title(); ?></h2>
			<div class="entry">
				<?php the_content('<p class="serif">Read the rest of this page &raquo;</p>'); ?>
				
				<ul>
					<?php get_nested_allarchives(); ?>
				</ul>

				<?php wp_link_pages(array('before' => '<p><strong>Pages:</strong> ', 'after' => '</p>', 'next_or_number' => 'number')); ?>

			</div>
		</div>
		<?php endwhile; endif; ?>
	<?php edit_post_link('Edit this entry.', '<p>', '</p>'); ?>
	</div>

<?php get_sidebar(); ?>

<?php get_footer(); ?>